Subject: Re: device trees.

From: "David H. Lynch Jr." <[email-masked]>
Date: Thu, 14 May 2009 08:51:17 -0400

David Gibson wrote:
>>
>> It is not THE dtb, it is A dtb. Our systems support and typically use
>> multiple FPGA bit streams.
>>     
>
> Ah, ok.  And those multiple bitstreams all inhabit the same NOR flash?
> From what I read below I'm guessing not..
>   
    In my work they virtually always do, but in clusters our cards
typically do not contain CPU's or Flash.

>
>
> Ok.  But they must be using some tool to push the bitstream into the
> board yes?  Could that same tool be made to take a bitstream+dtb
> bundle and push each piece into the right section of flash?
>   
    The entire flash is treated as a FileSystem.
    Bitstreams are written to it as files.
     When a pico card is hosted it looks like a disk to the host.
    Whne it is standalone, monitor does file reads/writes/directories,
    exeutes elf's and loads new bitstreams

>> Worse still the wrong dtb will probably mostly work. If it just failed
>> they would be more likely to grasp what they got wrong.
>>
>> I need/want the device tree welded to the bitstream. That means creating
>> it dynamically or welding it to the bitstream.
>> Anything else wil be a support nightmare.
>>     
>
> Right.  I guess it's all a question of what constitutes "welded" given
> the tool setup that's typically used by your clients.  I'm trying to
> understand enough about your system to make practical suggestions of
> how to achieve weldedness.
>   

    It is not just about a system, it is a family of systems, that are
similar but not identical.
    And are used for an extremely wide variety of purposes.
    My personal focus is Pico cards as embedded systems. That is about
1/3 of our market.
    1/3 is clusters, and 1/3 is custom systems that are designed similar
to our cards but
    are produced in volume for the specific needs of the client. These
typically do not have an OS
    and this is one of the places the spartans show up.

-- 
Dave Lynch 					  	    DLA Systems
Software Development:  				         Embedded Linux
717.627.3770 	       [email-masked] 	  http://www.dlasys.net
fax: 1.253.369.9244 			           Cell: 1.717.587.7774
Over 25 years' experience in platforms, languages, and technologies too numerous to list.

"Any intelligent fool can make things bigger and more complex... It takes a touch of genius - and a lot of courage to move in the opposite direction."
Albert Einstein